#line 1 "d:/_development_/rtu_mikroe/os.c"
#line 1 "d:/_development_/rtu_mikroe/taskdefs.h"
void backgroundtask (void);
void f1(void);
void f2(void);
void f3(void);
void f4(void);
void f5(void);
void f6(void);
#line 20 "d:/_development_/rtu_mikroe/os.c"
volatile unsigned char tick;


volatile unsigned char b_status;


unsigned int kernel_address;
volatile unsigned char kh;
volatile unsigned char kl;


typedef struct {
unsigned char taskstatus;
unsigned char tickcount;
unsigned char decrement;
} task_info;


void Timer0_COMP_Interrupt() iv IVT_ADDR_TIMER0_COMP ics ICS_OFF
{
#line 47 "d:/_development_/rtu_mikroe/os.c"
 asm { push r16
 in r16,SREG
 push r16 };

 asm { lds r16,_tick
 inc r16
 brcc 1f
 inc r16
 1f:
 sts _tick,r16};


 asm {lds r16,_b_status ; load background task flag
 subi r16,02
 BREQ 2f
 pop r16
 out SREG,r16
 pop r16
 reti
 2f:
 ldi r16,0x04
 sts _b_status,r16
 push R0
 push R1
 push R2
 push R3
 push R4
 push R5
 push R6
 push R7
 push R8
 push R9
 push R10
 push R11
 push R12
 push R13
 push R14
 push R15
 push R17
 push R18
 push R19
 push R20
 push R21
 push R22
 push R23
 push R24
 push R25
 push R26
 push R27
 push R28
 push R29
 push R30
 push R31
 lds r16,_kl
 push r16
 lds r16,_kh
 push r16
 ldi r16,0x00
 out SREG,r16
 reti
 };
}

void os_startup (void)
{

 OCR0 =  0x4E ;
 TCCR0 =  0x06  | 0x08;
 TCNT0 = 0x00;
 TIMSK = 0x02;

 MCUCR = 0x20;
 tick = 0;
  SREG_I_bit = 1 ;
}




task_info os_task[ 3 ];

void (*f[])(void) = { f1, f2, f3, backgroundtask };
void kernel ( void );
void task_setup(void)
{
 os_task[0].taskstatus =  0x00 ;
 os_task[0].tickcount = 2;
 os_task[0].decrement = os_task[0].tickcount;

 os_task[1].taskstatus =  0x00 ;
 os_task[1].tickcount = 4;
 os_task[1].decrement = os_task[1].tickcount;

 os_task[2].taskstatus =  0x00 ;
 os_task[2].tickcount = 40;
 os_task[2].decrement = os_task[2].tickcount;

 b_status =  0x00 ;

 kernel_address = (unsigned int ) &kernel;
 kh = (char) (kernel_address >> 8);
 kl = (char) (kernel_address );

}


void kernel ( void )
{
unsigned char i;

 while (1)
 {
 if (tick != 0)
 {

  SREG_I_bit = 0 ;
 TIMSK = TIMSK & 0xFD;
  SREG_I_bit = 1 ;
 for (i= 0; i <( 3 ) ; i++)
 {


 if (os_task[i].taskstatus !=  0x08 )
 {

 os_task[i].decrement = os_task[i].decrement - tick;

 if (os_task[i].decrement > os_task[i].tickcount)
 {
 os_task[i].decrement = 255 - os_task[i].decrement ;
 os_task[i].decrement = os_task[i].tickcount - os_task[i].decrement -1;
#line 180 "d:/_development_/rtu_mikroe/os.c"
 if(os_task[i].taskstatus ==  0x00 )
 {


 os_task[i].taskstatus =  0x01 ;

 }
 else
 {

 }
 }
 else
 {

 }
 }
 else
 {
 }
 }

 tick=0;

  SREG_I_bit = 0 ;
 TIMSK = TIMSK | 0x02;
  SREG_I_bit = 1 ;

 for (i=0 ;i<( 3 );i++)
 {
 if (os_task[i].taskstatus ==  0x01 )
 {
 os_task[i].taskstatus =  0x02 ;
 f[i]();
  SREG_I_bit = 0 ;
 os_task[i].taskstatus =  0x00 ;
  SREG_I_bit = 1 ;
 }

 }
#line 223 "d:/_development_/rtu_mikroe/os.c"
 if (tick==0)
 {
  SREG_I_bit = 0 ;
 if (b_status ==  0x00 )
 {
 b_status =  0x02 ;
 f[ 3 ]();
  SREG_I_bit = 0 ;
 b_status =  0x00 ;
  SREG_I_bit = 1 ;
 }
 else if (b_status ==  0x04 )
 {
 b_status =  0x02 ;
 asm {
 pop r31
 pop R30
 pop R29
 pop R28
 pop R27
 pop R26
 pop R25
 pop R24
 pop R23
 pop R22
 pop R21
 pop R20
 pop R19
 pop R18
 pop R17
 pop R15
 pop R14
 pop R13
 pop R12
 pop R11
 pop R10
 pop R9
 pop R8
 pop R7
 pop R6
 pop R5
 pop R4
 pop R3
 pop R2
 pop R1
 pop R0
 pop r16
 out SREG,r16
 pop r16
 reti
 }
 }
 }

 }

 if(tick==0)
 {
 asm { sleep };
 }

 }
}

void main()
{
 task_setup();
 os_startup();
 kernel();

 while(1);
}
